// Tonality:
// 
// Extension of Rational class allowing for tonalities 
// within a basic tuning, much like Partch's system.

public class Tonality extends Rational
{
	FileIO tFile;
	float tMap[128];
	
	public void readTonality(string tFilename)
	{
		
		float tBaseMap[0];
		
		tFile.open( tFilename, FileIO.READ );
		
		if ( !tFile.good() ) {
			<<< "can't open file: ", tFilename, " for reading." >>>;
			me.exit();
		}
		
		<<< "Name of tonality is: ", tFile.readLine() >>>;
		
		for ( int i; tFile.more(); i++ ) {
			tBaseMap << Rational.rBaseMap[tFile.readInt()];
			
			<<< "Tonality element ", i, " is: ", tBaseMap[i] >>>;
		}
		
		<<< "Tonality is ", tBaseMap.size(), "elements long." >>>;
		
		for ( 0 => int i; i < tMap.size(); i++ ) {
			tBaseMap[ ( ( i + Rational.rOffSet ) % tBaseMap.size() ) ] *
			Math.pow(2, Rational.rDiasponOffSet + 
			Math.floor( ( ( i + Rational.rOffSet ) / tBaseMap.size() ) ) ) 
			=> tMap[i];
		}
		<<< "Success in loading new tonality." >>>;
	}	
	
	
	public float t(int key)
	{
		return tMap[key];
	}
}