Tonality otonal1;
otonal1.readTonality("otonal1.tonality");

Gain main => Echo plex => JCRev rev => dac;

main.gain(0.7);
plex.delay(100::ms);
plex.max(1000::ms);
plex.mix(0.1);

plex => main;

rev.mix(0.1);

// device to open
4 => int device;
// get from command line
if( me.args() ) me.arg(0) => Std.atoi => device;

MidiIn min;
MidiMsg msg;

// try to open MIDI port (see chuck --probe for available devices)
if( !min.open( device ) ) me.exit();

// print out device that was opened
<<< "MIDI device:", min.num(), " -> ", min.name() >>>;

// make our own event
class NoteEvent extends Event
{
	int note;
	int velocity;
}

// the event
NoteEvent on;
// array of ugen's handling each note
Event @ us[128];

// handler shred for a single voice
fun void handler()
{
	// don't connect to dac until we need it
	// c.preset(4);
	Wurley player;
	
	
	Event off;
	int note;
	
	float velocitycurve;
	
	// inifinite time loop
	while( true )
	{
		on => now;
		on.note => note;
		
		player => main;
		
		(on.velocity / 12.7) => velocitycurve;
		Math.log10(velocitycurve) => velocitycurve;
		
		// <<< tuner.getpitch( note ) >>>;
		player.freq(otonal1.t(note));
		player.noteOn(velocitycurve);
		
		off @=> us[note];
		off => now;
		
		player.noteOff(0.5);
		null @=> us[note];
		150::ms => now;
		player =< main;
	}
}

// spork handlers, one for each voice
for( 0 => int i; i < 20; i++ ) spork ~ handler();

// infinite time loop
while( true )
{
	// wait on midi event
	min => now;
	
	// get the midimsg
	while( min.recv( msg ) )
	{
		// catch only noteon
		//if( msg.data1 != 144 )
		//    continue;
		
		// check velocity
		if( msg.data1 == 144 )
		{
			// store midi note number
			msg.data2 => on.note;
			// store velocity
			msg.data3 => on.velocity;
			// signal the event
			on.signal();
			// yield without advancing time to allow shred to run
			me.yield();
		}
		else
		{
			if( us[msg.data2] != null ) us[msg.data2].signal();
	}
}
}